osmium::io::InputIterator< TSource, TItem > Class Template Reference

`#include <input_iterator.hpp>`

Collaboration diagram for osmium::io::InputIterator< TSource, TItem >:
[legend]

## Public Types

typedef std::input_iterator_tag | iterator_category
typedef TItem | value_type
typedef ptrdiff_t | difference_type
typedef TItem * | pointer
typedef TItem & | reference

## Public Member Functions

| InputIterator (TSource &source)
| InputIterator () noexcept
InputIterator & | operator++ ()
InputIterator | operator++ (int)
bool | operator== (const InputIterator &rhs) const noexcept
bool | operator!= (const InputIterator &rhs) const noexcept
reference | operator* () const
pointer | operator-> () const

## Private Types

typedef osmium::memory::Buffer::t_iterator< TItem > | item_iterator

## Private Member Functions

void | update_buffer ()

## Private Attributes

TSource * | m_source
std::shared_ptr< osmium::memory::Buffer > | m_buffer
item_iterator | m_iter {}

## Detailed Description

### template<typename TSource, typename TItem = osmium::memory::Item>
class osmium::io::InputIterator< TSource, TItem >

This iterator class allows you to iterate over all items from a source. It hides all the buffer handling and makes the contents of a source accessible as a normal STL input iterator.

## Member Typedef Documentation

template<typename TSource, typename TItem = osmium::memory::Item>

typedef ptrdiff_t osmium::io::InputIterator< TSource, TItem >::difference_type

template<typename TSource, typename TItem = osmium::memory::Item>

typedef osmium::memory::Buffer::t_iterator<TItem> osmium::io::InputIterator< TSource, TItem >::item_iterator

private

template<typename TSource, typename TItem = osmium::memory::Item>

typedef std::input_iterator_tag osmium::io::InputIterator< TSource, TItem >::iterator_category

template<typename TSource, typename TItem = osmium::memory::Item>

typedef TItem* osmium::io::InputIterator< TSource, TItem >::pointer

template<typename TSource, typename TItem = osmium::memory::Item>

typedef TItem& osmium::io::InputIterator< TSource, TItem >::reference

template<typename TSource, typename TItem = osmium::memory::Item>

typedef TItem osmium::io::InputIterator< TSource, TItem >::value_type

## Constructor & Destructor Documentation

template<typename TSource, typename TItem = osmium::memory::Item>

osmium::io::InputIterator< TSource, TItem >::InputIterator | ( | TSource & | source | ) |

inline explicit

template<typename TSource, typename TItem = osmium::memory::Item>

osmium::io::InputIterator< TSource, TItem >::InputIterator | ( |  | ) |

inline noexcept

## Member Function Documentation

template<typename TSource, typename TItem = osmium::memory::Item>

bool osmium::io::InputIterator< TSource, TItem >::operator!= | ( | const InputIterator< TSource, TItem > & | rhs | ) | const

inline noexcept

template<typename TSource, typename TItem = osmium::memory::Item>

reference osmium::io::InputIterator< TSource, TItem >::operator* | ( |  | ) | const

inline

template<typename TSource, typename TItem = osmium::memory::Item>

InputIterator& osmium::io::InputIterator< TSource, TItem >::operator++ | ( |  | ) |

inline

template<typename TSource, typename TItem = osmium::memory::Item>

InputIterator osmium::io::InputIterator< TSource, TItem >::operator++ | ( | int |  | ) |

inline

template<typename TSource, typename TItem = osmium::memory::Item>

pointer osmium::io::InputIterator< TSource, TItem >::operator-> | ( |  | ) | const

inline

template<typename TSource, typename TItem = osmium::memory::Item>

bool osmium::io::InputIterator< TSource, TItem >::operator== | ( | const InputIterator< TSource, TItem > & | rhs | ) | const

inline noexcept

template<typename TSource, typename TItem = osmium::memory::Item>

void osmium::io::InputIterator< TSource, TItem >::update_buffer | ( |  | ) |

inline private

## Member Data Documentation

template<typename TSource, typename TItem = osmium::memory::Item>

std::shared_ptr<osmium::memory::Buffer> osmium::io::InputIterator< TSource, TItem >::m_buffer

private

template<typename TSource, typename TItem = osmium::memory::Item>

item_iterator osmium::io::InputIterator< TSource, TItem >::m_iter {}

private

template<typename TSource, typename TItem = osmium::memory::Item>

TSource* osmium::io::InputIterator< TSource, TItem >::m_source

private

The documentation for this class was generated from the following file:

- osmium/io/input_iterator.hpp